commit 302eb5361d703e279043560a3d4ffefe6b610ad6
Author: Richard Earnshaw <rearnsha@arm.com>
Date:   Tue Jul 27 16:44:57 2021

    arm: Don't reconfigure globals in arm_configure_build_target
    
    arm_configure_build_target is usually used to reconfigure the
    arm_active_target structure, which is then used to reconfigure a
    number of other global variables describing the current target.
    Occasionally, however, we need to use arm_configure_build_target to
    construct a temporary target structure and in that case it is wrong to
    try to reconfigure the global variables (although probably harmless,
    since arm_option_reconfigure_globals() only looks at
    arm_active_target).  At the very least, however, this is wasted work,
    so it is best not to do it unless needed.  What's more, several
    callers of arm_configure_build target call
    arm_option_reconfigure_globals themselves within a few lines, making
    the call from within arm_configure_build_target completely redundant.
    
    So this patch moves the responsibility of calling of
    arm_configure_build_target to its callers (only two places needed
    updating).
    
    gcc:
            * config/arm/arm.c (arm_configure_build_target): Don't call
            arm_option_reconfigure_globals.
            (arm_option_restore): Call arm_option_reconfigure_globals after
            reconfiguring the target.
            * config/arm/arm-c.c (arm_pragma_target_parse): Likewise.
    (cherry picked from commit 6a37d0331c25f23628d4308e5a75624005c223b2)

diff --git a/gcc/config/arm/arm-c.c b/gcc/config/arm/arm-c.c
index ae2139c4bfa..cc7901bca8d 100644
--- a/gcc/config/arm/arm-c.c
+++ b/gcc/config/arm/arm-c.c
@@ -409,6 +409,7 @@ arm_pragma_target_parse (tree args, tree pop_target)
       target_option_current_node = cur_tree;
       arm_configure_build_target (&arm_active_target,
 				  TREE_TARGET_OPTION (cur_tree), false);
+      arm_option_reconfigure_globals ();
     }
 
   /* Update macros if target_node changes. The global state will be restored
